﻿/*
* Copyright 2009-2010 AKABANA.
*
* Licensed under the Apache License, Version 2.0 (the "License");
* you may not use this file except in compliance with the License.
* You may obtain a copy of the License at
*
*     http://www.apache.org/licenses/LICENSE-2.0
*
* Unless required by applicable law or agreed to in writing, software
* distributed under the License is distributed on an "AS IS" BASIS,
* WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, 
* either express or implied. See the License for the specific language
* governing permissions and limitations under the License.
*/
using System;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Ink;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using System.Windows.Interactivity;

using Akabana.Amf.Messaging;
using Akabana.Amf.Messaging.Service;

namespace Akabana.Amf.Messaging.Interactivity
{
    public class ServiceBehavior<T> : Behavior<T> where T : System.Windows.FrameworkElement
    {

        private const string SERVICE = "Service";

        protected override void OnAttached()
        {
            base.OnAttached();

            AssociatedObject.Loaded += new RoutedEventHandler(AssociatedObject_Loaded);
        }

        protected override void OnDetaching()
        {
            base.OnDetaching();
        }

        protected void AssociatedObject_Loaded(object sender, RoutedEventArgs e)
        {
            setupServices();
        }

        protected void setupServices()
        {
            var type = this.GetType();

            foreach (var field in type.GetFields())
            {
                if (field.Name.IndexOf(SERVICE) > 0)
                {
                    var attributes = field.FieldType.GetCustomAttributes(true);

                    foreach (var attribute in attributes)
                    {
                        if (attribute is MessagingServiceAttribute)
                        {
                            field.SetValue(this, ServiceFactory.NewInstance(field.FieldType));
                            break;
                        }
                    }
                }
            }
        }
    }
}
