﻿/*
* Copyright 2009-2010 AKABANA.
*
* Licensed under the Apache License, Version 2.0 (the "License");
* you may not use this file except in compliance with the License.
* You may obtain a copy of the License at
*
*     http://www.apache.org/licenses/LICENSE-2.0
*
* Unless required by applicable law or agreed to in writing, software
* distributed under the License is distributed on an "AS IS" BASIS,
* WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, 
* either express or implied. See the License for the specific language
* governing permissions and limitations under the License.
*/
using System.Net;

using Akabana.Amf.Messaging.Data;


namespace Akabana.Amf.Messaging.Component
{
    public class AmfMessageRequest
    {
        public static AmfMessageRequest NewInstance(HttpWebRequest httpWebRequest, Responder responder, AmfMessage amfMessage)
        {
            var result = new AmfMessageRequest();
            result.Request = httpWebRequest;
            result.Responder = responder;
            result.Message = amfMessage;

            return result;
        }

        public HttpWebRequest Request { get; private set; }

        public Responder Responder { get; private set; }

        public AmfMessage Message { get; private set; }

        private AmfMessageRequest()
        {
        }
    }
}
