﻿/*
* Copyright 2009-2010 AKABANA.
*
* Licensed under the Apache License, Version 2.0 (the "License");
* you may not use this file except in compliance with the License.
* You may obtain a copy of the License at
*
*     http://www.apache.org/licenses/LICENSE-2.0
*
* Unless required by applicable law or agreed to in writing, software
* distributed under the License is distributed on an "AS IS" BASIS,
* WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, 
* either express or implied. See the License for the specific language
* governing permissions and limitations under the License.
*/
using System.Windows;


namespace Akabana.Amf.Messaging.Component
{

    public delegate void FaultCallBack(Fault fault);

    public delegate void ResultCallBack(object result);

    public class Responder : DependencyObject
    {
        public ResultCallBack ResultCallBack { get; private set; }

        public FaultCallBack FaultCallBack { get; private set; }

        public Responder(ResultCallBack resultCallBack, FaultCallBack faultCallBack)
        {
            this.ResultCallBack = resultCallBack;
            this.FaultCallBack = faultCallBack;
        }

        public void Response(string type, object data)
        {
            if (type == "/onResult")
            {

                if (ResultCallBack.Method.GetParameters().Length > 0)
                {
                    Dispatcher.BeginInvoke(
                        () =>
                        {
                            ResultCallBack(data);
                        }
                    );
                }
                else
                {
                    Dispatcher.BeginInvoke(
                        () =>
                        {
                            ResultCallBack.DynamicInvoke();
                        }
                    );
                }
            }
            else
            {
                Dispatcher.BeginInvoke(
                    () =>
                    {
                        FaultCallBack(data as Fault);
                    }
                );
            }
        }

    }
}
