﻿/*
* Copyright 2009-2010 AKABANA.
*
* Licensed under the Apache License, Version 2.0 (the "License");
* you may not use this file except in compliance with the License.
* You may obtain a copy of the License at
*
*     http://www.apache.org/licenses/LICENSE-2.0
*
* Unless required by applicable law or agreed to in writing, software
* distributed under the License is distributed on an "AS IS" BASIS,
* WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, 
* either express or implied. See the License for the specific language
* governing permissions and limitations under the License.
*/
using System;
using System.Collections.Generic;
using System.Linq;
using System.IO;

using Akabana.Amf.IO;
using Akabana.Amf.Util;

namespace Akabana.Amf.Messaging.IO
{
    public class AmfMessageReader : AmfReader
    {

        public AmfMessageReader(Stream input)
            : base(input)
        {
        }

        public AmfMessageReader(Stream input, ushort version)
            : base(input,version)
        {
        }

        public ushort ReadHeaderCount()
        {
            return this.ReadU16();
        }

        public ushort ReadBodyCount()
        {
            return this.ReadU16();
        }

        public string ReadTarget()
        {
            return this.ReadUtfString();
        }

        public string ReadResponse()
        {
            return this.ReadUtfString();
        }

        public uint ReadMessageSize()
        {
            return this.ReadU32();
        }

    }
}
