﻿/*
* Copyright 2009-2010 AKABANA.
*
* Licensed under the Apache License, Version 2.0 (the "License");
* you may not use this file except in compliance with the License.
* You may obtain a copy of the License at
*
*     http://www.apache.org/licenses/LICENSE-2.0
*
* Unless required by applicable law or agreed to in writing, software
* distributed under the License is distributed on an "AS IS" BASIS,
* WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, 
* either express or implied. See the License for the specific language
* governing permissions and limitations under the License.
*/
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace Akabana.Amf.Messaging
{
    /**
     * <summary>リモーティングサービス属性</summary>
     * <example>
     * <code>
     * [MessagingServiceAttribute(name="ServiceName")]
     * public class TestRemotingService
     * {
     * }
     * </code>
     * </example>
     */
    [System.AttributeUsage(System.AttributeTargets.Class | System.AttributeTargets.Interface, AllowMultiple = false)]
    public class MessagingServiceAttribute : System.Attribute
    {
        public string Name { get; set; }

        public MessagingServiceAttribute()
        {
        }

        public MessagingServiceAttribute(string name)
        {
            this.Name = name;
        }
    }
}
