﻿/*
* Copyright 2009-2010 AKABANA.
*
* Licensed under the Apache License, Version 2.0 (the "License");
* you may not use this file except in compliance with the License.
* You may obtain a copy of the License at
*
*     http://www.apache.org/licenses/LICENSE-2.0
*
* Unless required by applicable law or agreed to in writing, software
* distributed under the License is distributed on an "AS IS" BASIS,
* WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, 
* either express or implied. See the License for the specific language
* governing permissions and limitations under the License.
*/
using System;
using Akabana.Amf.IO;

namespace Akabana.Amf.Serializer
{

    public abstract class AbstractAmfDeserializer : IAmfDeserializer
    {
        [ThreadStatic]
        private static IAmfReferenceTable referenceTable;

        protected AmfReader amfReader;

        public abstract object Deserialize();

        public AbstractAmfDeserializer(AmfReader amfReader)
        {
            this.amfReader = amfReader;
        }

        public virtual void referenceClear()
        {
            if (referenceTable != null)
            {
                referenceTable.Clear();
            }
            referenceTable = null;
        }

        protected IAmfReferenceTable GetReferenceTable()
        {
            if (referenceTable == null)
            {
                referenceTable = CreateReferenceTable();
            }
            return referenceTable;
        }

        protected abstract IAmfReferenceTable CreateReferenceTable();

    }
}
