﻿/*
* Copyright 2009-2010 AKABANA.
*
* Licensed under the Apache License, Version 2.0 (the "License");
* you may not use this file except in compliance with the License.
* You may obtain a copy of the License at
*
*     http://www.apache.org/licenses/LICENSE-2.0
*
* Unless required by applicable law or agreed to in writing, software
* distributed under the License is distributed on an "AS IS" BASIS,
* WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, 
* either express or implied. See the License for the specific language
* governing permissions and limitations under the License.
*/
using Akabana.Amf.Amf0.Serializer;
using Akabana.Amf.Amf3.Serializer;
using Akabana.Amf.IO;

namespace Akabana.Amf.Serializer
{

    public static class AmfSerializerFactory
    {

        public static IAmfSerializer CreateSerializer(int version,AmfWriter writer)
        {
            Amf0Serializer result = new Amf0Serializer(writer);
            result.referenceClear();
            if (version > 0)
            {
                result.SetAvmplusAmfSerializer(new Amf3Serializer(writer));
            }
            return result;
        }

        public static IAmfDeserializer CreateDeserializer(int version,AmfReader reader)
        {
            Amf0Deserializer result = new Amf0Deserializer(reader);
            result.referenceClear();
            if (version > 0)
            {
                result.SetAvmplusAmfDeserializer(new Amf3Deserializer(reader));
            }
            return result;
        }
    }
}
