﻿/*
* Copyright 2009-2010 AKABANA.
*
* Licensed under the Apache License, Version 2.0 (the "License");
* you may not use this file except in compliance with the License.
* You may obtain a copy of the License at
*
*     http://www.apache.org/licenses/LICENSE-2.0
*
* Unless required by applicable law or agreed to in writing, software
* distributed under the License is distributed on an "AS IS" BASIS,
* WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, 
* either express or implied. See the License for the specific language
* governing permissions and limitations under the License.
*/
using System;
using System.Globalization;

namespace Akabana.Amf.Util
{
    public static class DateUtil
    {

        private static DateTime BASE_DATETIME = new DateTime( 1970, 1, 1, 0, 0, 0, Calendar.CurrentEra, DateTimeKind.Utc);

        public static long ToUtcMillSec(DateTime value)
        {
            long time = (long)((value.ToUniversalTime().Ticks - BASE_DATETIME.Ticks) / 10000);
            return time;
        }

        public static DateTime ToUtcDateTime(double value)
        {
            return BASE_DATETIME.AddTicks((long)((decimal)(value * 10000))).ToLocalTime();
        }
    }
}
