﻿/*
* Copyright 2009-2010 AKABANA.
*
* Licensed under the Apache License, Version 2.0 (the "License");
* you may not use this file except in compliance with the License.
* You may obtain a copy of the License at
*
*     http://www.apache.org/licenses/LICENSE-2.0
*
* Unless required by applicable law or agreed to in writing, software
* distributed under the License is distributed on an "AS IS" BASIS,
* WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, 
* either express or implied. See the License for the specific language
* governing permissions and limitations under the License.
*/
using System.Globalization;

namespace Akabana.Amf.Util
{
    public static class StringExt
    {
        public static string ToLowerCamel(this string str)
        {
            string head = str.Substring(0, 1).ToLower(CultureInfo.CurrentCulture);
            string result = head + str.Substring(1, str.Length - 1);
            return result;
        }

        public static string ToUpperCamel(this string str)
        {
            string head = str.Substring(0, 1).ToUpper(CultureInfo.CurrentCulture);
            return head + str.Substring(1, str.Length - 1);
        }

        public static bool IsEmpty(this string str)
        {
            return (str == null) || (str.Length == 0);
        }
    }
}
