﻿/*
* Copyright 2009-2010 AKABANA.
*
* Licensed under the Apache License, Version 2.0 (the "License");
* you may not use this file except in compliance with the License.
* You may obtain a copy of the License at
*
*     http://www.apache.org/licenses/LICENSE-2.0
*
* Unless required by applicable law or agreed to in writing, software
* distributed under the License is distributed on an "AS IS" BASIS,
* WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, 
* either express or implied. See the License for the specific language
* governing permissions and limitations under the License.
*/
using System;

namespace Akabana.Amf.Util
{
    public static class TypeExt
    {
        public static bool IsNullable(this Type type)
        {
            return type.IsGenericType && (type.GetGenericTypeDefinition() == typeof(Nullable<>));
        }

        public static bool IsSimpleObject(this Type type)
        {
            return type.IsPrimitive || type.IsValueType || (Type.GetTypeCode(type) == TypeCode.String);
        }

        public static object CreateInstance(this Type type)
        {
            return Activator.CreateInstance(type);
        }

        public static bool IsAMFPrimitive(this Type type)
        {
            return type.IsPrimitive || (Type.GetTypeCode(type) == TypeCode.DateTime);
        }

        public static bool IsAMFValueType(this Type type)
        {
            return type.IsValueType && (Type.GetTypeCode(type) != TypeCode.DateTime);
        }
    
    }
}
